#include <Windows.h>
#include "resource.h"
#include "Includes.h"
#include <vector>
using namespace std;


//_______GLOBAL_VARIABLES____________________________________________________________
	extern ea_t addrScreenCursor;
	extern ea_t addrBeginSeg;
	extern ea_t addrEndSeg;

	extern _int64 _BDUMP;
	extern _int64 _EDUMP;

	HWND _hwnd;

	int Result = 0;

//_______PROTORYPE____________________________________________________________________
BOOL CALLBACK DialogProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
_int64 ConvertStringNumber(const WCHAR* str);
void ConvertNumberString(int arg, WCHAR* buff);
//BOOL ReadBase();
//BOOL WrireBase();

//    :: get border dump memory
int  GetBorderDump()
{

	auto hInst = GetModuleHandle(L"DumpMemory64.dll");
	return DialogBoxParam(hInst, MAKEINTRESOURCE(ID_DIALOG1), 0, (DLGPROC)DialogProc, 0);
}

//   :: procedure callback message
BOOL CALLBACK DialogProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	//struct
	PAINTSTRUCT ps{ 0 };
	WCHAR buff_BDUMP[MAX_PATH] = { 0 };
	WCHAR buff_EDUMP[MAX_PATH] = { 0 };
	//value 
	
	//buff
	WCHAR buff[MAX_PATH] = { 0 };

	switch (msg)
	{
	case WM_INITDIALOG:
		_hwnd = hwnd;
		//  IDE__BSEG,IDE_ESEB,IDE_BDUMP,IDE_EDUMP
		ConvertNumberString(addrBeginSeg, buff);
		SendDlgItemMessage(hwnd, IDE_BSEG, WM_SETTEXT, 0, (LPARAM)buff);
		ConvertNumberString(addrEndSeg, buff);
		SendDlgItemMessage(hwnd, IDE_ESEG, WM_SETTEXT, 0, (LPARAM)buff);
		ConvertNumberString(addrScreenCursor, buff);
		SendDlgItemMessage(hwnd, IDE_BDUMP, WM_SETTEXT, 0, (LPARAM)buff);
		ConvertNumberString(addrEndSeg, buff);
		SendDlgItemMessage(hwnd, IDE_EDUMP, WM_SETTEXT, 0, (LPARAM)buff);
		break;

	case WM_COMMAND:
		switch (HIWORD(wparam))
		{
		case BN_CLICKED:
			switch (LOWORD(wparam))
			{
			case IDB_OK:
				//  IDE_BDUMP  IDE_EDUMP
				ZeroMemory(buff_BDUMP, sizeof(WCHAR)*MAX_PATH);
				ZeroMemory(buff_EDUMP, sizeof(WCHAR)*MAX_PATH);
				SendDlgItemMessage(_hwnd, IDE_BDUMP, WM_GETTEXT, MAX_PATH, (LPARAM)buff_BDUMP);
				SendDlgItemMessage(_hwnd, IDE_EDUMP, WM_GETTEXT, MAX_PATH, (LPARAM)buff_EDUMP);
				//   
				_BDUMP = ConvertStringNumber(buff_BDUMP);
				_EDUMP = ConvertStringNumber(buff_EDUMP);
				// 
				if (_BDUMP == -1 || _EDUMP == -1)
					MessageBox(0, L"Imput wrong number, please re-enter", L"Warning", MB_ICONWARNING);
				else
				{
					Result = 1;					
					SendMessage(hwnd, WM_CLOSE, 0, 0);
				}
				break;

			case IDB_CANCEL:
				Result = -1;
				_BDUMP = 0;
				_EDUMP = 0;
				SendMessage(hwnd, WM_CLOSE, 0, 0);
				break;
			}
			break;
		}

	case WM_SIZE:
		break;

	case WM_PAINT:
		break;

	case WM_CLOSE:
		EndDialog(hwnd, Result);
		return FALSE;
	}

	return FALSE;
}

//   ::convert string to number
_int64 ConvertStringNumber(const WCHAR* str)
{
	//flag 
	BOOL Flag_HEX = FALSE;
	//buf 
	_int64 ReturnNumber = 0;
	int TempValue = 0;
	int length = lstrlen(str);

	if (str[0] == 0x30 && length > 2)
		if (str[1] == 0x78 || str[1] == 0x445)
			Flag_HEX = TRUE;

	if (Flag_HEX == TRUE)
	{
		for (size_t i = 2; i < length; i++)
		{
			if (str[i] >= 0x30 && str[i] <= 0x39 ||
				str[i] >= 0x41 && str[i] <= 0x46)
			{
				TempValue = str[i] - 0x30;
				ReturnNumber = (ReturnNumber << 4) + TempValue;
			}
			else if (str[i] >= 0x61 && str[i] <= 0x66)
			{
				TempValue = str[i] - 0x57;
				ReturnNumber = (ReturnNumber << 4) + TempValue;
			}
			else
				return -1;
		}
		return ReturnNumber;
	}
	else
	{
		for (size_t i = 0; i < length; i++)
		{
			if (str[i] >= 0x30 && str[i] <= 0x39)
			{
				TempValue = str[i] - 0x30;
				ReturnNumber = (ReturnNumber * 10) + TempValue;
			}
			else
				return -1;
		}
		return ReturnNumber;
	}

}

//    
void ConvertNumberString(int arg, WCHAR* buff)
{
	//buff
	ZeroMemory(buff, sizeof(WCHAR)*MAX_PATH);
	WCHAR mask_hex[] = L"0x%X";
	wsprintf(buff, mask_hex, arg);
	return;
}



/*
//        :: read the base and filling array pointers on lines
 BOOL ReadBase()
 {
	 //  :: Open the file
	 auto hFile = CreateFileW(L"DumpMemory64.msv", GENERIC_READ,
		 FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	 if (hFile == INVALID_HANDLE_VALUE)
		 return FALSE;

	 DWORD HighDword = 0, LowDword = 0;
	 LowDword = GetFileSize(hFile, &HighDword);

	 WORD* buff = new WORD[LowDword / 2];

	 //  :: read the file 
	 if (ReadFile(hFile, buff, LowDword, &HighDword, 0) == 0)
	 {
		 CloseHandle(hFile);
		 return FALSE;
	 }

	 //   :: filling array pointers
	 for (int i = 0; i < (LowDword/2); i++)
	 {
		 _PString.push_back((LPCWCHAR)&buff[i]);
		 while (buff[i] == 0)
			 i++;
	 }
	 CloseHandle(hFile);
	 return true;
 }

//        :: write to the base lines from array pointers
 BOOL WrireBase()
 {
	 //    :: create file for write
	 DeleteFile(L"DumpMemory64.msv");
	 auto hFile = CreateFileW(L"DumpMemory64.msv", GENERIC_WRITE,
		 FILE_SHARE_READ, 0, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, 0);
	 if (hFile == INVALID_HANDLE_VALUE)
		 return FALSE;

	 int iP = _PString.size();
	 WORD* buff = new WORD[5000];
	 for (size_t i = 0, j = 0; i < iP; i++)
	 {
		 auto Pointer = _PString.at(i);					//    
		 while (Pointer[j] == 0)
		 {
			 buff[j] = Pointer[j];                     //     WORDs   
			 j++;
		 }
		 buff[j] = Pointer[j];
		 j = 0;
	 }

	 DWORD pDword = 0;
	 WriteFile(hFile, buff, sizeof(buff), &pDword, 0);
	 CloseHandle(hFile);
	 return true;
 }

//   ComboBox 
 BOOL WriteComboBox()
 {
	 int Size = _PString.size();
	 for (int i = 0; i < Size; i++)
	 {
		 int index = SendDlgItemMessage(_hwnd, IDC_BSEG, CB_ADDSTRING, 0, (LPARAM)_PString.at(i));
		 SendDlgItemMessage(_hwnd, IDC_BSEG, CB_SETITEMDATA, (WPARAM)index, (LPARAM)_PString.at(i));
	 }
 }
 
 //   ComboBox
 BOOL ReadComboBox()
 {
	 auto size = SendDlgItemMessage(_hwnd, IDC_BSEG, CB_GETCOUNT, 0, 0);											//    
	 _PString.clear();
	 for (int i = 0; i < size; i++)
	 {
	   
		auto Pointer = SendDlgItemMessage(_hwnd, IDC_BSEG, CB_GETITEMDATA, (WPARAM)i, NULL);                    //     
		if(Pointer != 0)
			_PString.push_back((LPCWCHAR)Pointer);
	 }
 }

// int index = SendDlgItemMessage(_hwnd, IDC_BSEG, CB_GETCURSEL, NULL, NULL);                   //   
*/